C******************** START FILE GET1F2.FOR ; GROUP UTL2D ******************
C------------------------------------------------------------------
C  ROUTINES FOR PULLING SLICES IN/OUT OF 2D DATA ARRAYS
C
      SUBROUTINE GET1F2(IDIM,IFIX,F,NF1,NF2,N1USE,WK,NWK)
C
      REAL F(NF1,NF2),WK(NWK)
C
C  EXTRACT A ROW OR COLUMN OF F (2D) INTO WORK ARRAY (1D)
C
      N2USE=NF2
C  ERROR CHECKING
      IF(IDIM.EQ.1) THEN
        CALL WKCHK(NWK,N1USE,'GET1F2',IER)
        IF(IER.NE.0) RETURN
      ELSE IF(IDIM.EQ.2) THEN
        CALL WKCHK(NWK,N2USE,'GET1F2',IER)
        IF(IER.NE.0) RETURN
      ENDIF
C
C  LOAD WORK VECTOR
      IF(IDIM.EQ.1) THEN
        DO IX=1,N1USE
          WK(IX)=F(IX,IFIX)
        ENDDO
      ELSE IF(IDIM.EQ.2) THEN
        DO IY=1,N2USE
          WK(IY)=F(IFIX,IY)
        ENDDO
      ENDIF
C
      RETURN
      END
C******************** END FILE GET1F2.FOR ; GROUP UTL2D ******************

      program tgtest
C
C  generate some plots -- trgraf display routines test program
C
      integer nsize,nsiz2
      parameter (nsize=1000)            ! data curves
      parameter (nsizy=300)             ! for f(x,y)
      parameter (nsiz2=30)              ! simulated data pts for fitting
C
      real zx(nsize),zcos(nsize),zsin(nsize),zsin2(nsize),zsin3(nsize)
      real zwk(nsize),zy(nsizy)
C
      real f2d(nsize,nsizy)
C
      real zxdata(nsiz2),zdata(nsiz2),zerx(nsiz2),zery(nsiz2)
C
      real rc(nsize,4),yc(nsize,4)      ! contour set
      real zz(4)
      integer iselec(4)
C
      character*60 mnlab(3)
      character*17 kylab(5)
      character*10 lbsel(15)
C
      logical lchar,lxout
C
      character*60 zlbl
C
      data zz/1.,2.,3.,4./
C
C-------------------
C
      call uinitg('TGTEST')
      luntrm=lnout(0)
C
      zlbl='tgtest:  trgraf test program'
C
      twopi=6.283185
C
      do ix=1,nsize
         zth=twopi*float(ix-1)/float(nsize-1)
         zx(ix)=zth
         zcos(ix)=cos(zth)
         zsin(ix)=sin(zth)
         zsin2(ix)=sin(2.0*zth)
         zsin3(ix)=sin(3.0*zth)
         do i=1,4
            rc(ix,i)=zcos(ix)
         enddo
         yc(ix,1)=zcos(ix)
         yc(ix,2)=zsin(ix)
         yc(ix,3)=zsin2(ix)
         yc(ix,4)=zsin3(ix)
      enddo
C
      do iy=1,nsizy
         zthy=twopi*float(iy-1)/float(nsizy-1)
         zy(iy)=zthy
         zcosy=cos(zthy)
         do ix=1,nsize
            zth=twopi*float(ix-1)/float(nsize-1)
            f2d(ix,iy)=zcosy*cos(2.0*zth)
         enddo
      enddo
C
      zfac=0.1
      do j=1,nsiz2
         zxdata(j)=twopi*float(j-1)/float(nsiz2-1)
         zth=zxdata(j)
         zth100=100.0*zth
         zdata(j)=sin(zth)+zfac*cos(zth100)
         zery(j)=zfac*(1.0+sin(zth100)**2)
         zerx(j)=zfac*(1.0+abs(sin(zth))/(0.25+abs(cos(zth))))
      enddo
C
 10   continue
C
      if(lxout(0)) write(luntrm,1001)
 1001 format(/
     >' tgtest test plot options:'/
     >'  1 -- basic f(x) plot'/
     >'  2 -- {f1(x),f2(x)} plot'/
     >'  3 -- {f1(x),f2(x),f3(x)} plot'/
     >'  4 -- {f1(x),f2(x),f3(x),f4(x)} plot'/
     >'  C -- plot of contour traces'/
     >'  F -- "data fit" plot'/
     >'  E -- "data fit" plot with error bars'/
     >'  G -- plot of f(x,y) data'/
     >'  Q -- quit')
      call uread('tgtest:  enter 1 character option code:$')
      if(lchar('Q')) then
         call uexita(0)
         stop
      else if(lchar('1')) then
C  f(x)
         call grafx1(zx,zcos,nsize,'x','y',zlbl,
     >      'basic f(x) plot','y=cos(x)')
      else if(lchar('2')) then
C  2 fcns
         call grafx2(zx,zcos,zsin,nsize,'x','y',zlbl,
     >      '{f1(x),f2(x)} plot','cos(x), sin(x)')
      else if(lchar('3')) then
C  3 fcns
         call grafx3(zx,zcos,zsin,zsin2,nsize,'x','y',zlbl,
     >      '{f1(x),f2(x),f3(x)} plot','cos(x), sin(x), sin(2*x)')
      else if(lchar('4')) then
C  4 fcns
         call grafx4(zx,zcos,zsin,zsin2,zsin3,nsize,'x','y',zlbl,
     >      '{f1(x),f2(x),f3(x),f4(x)} plot',
     >      'cos(x), sin(x), sin(2*x), sin(3*x)')
      else if(lchar('F')) then
C  "data fit"
         call grafxf(zx,zsin,nsize,zxdata,zdata,nsiz2,'x','y',zlbl,
     >      'f(x) as fit around data points','y=sin(x)')
      else if(lchar('E')) then
C  "data fit with error bars"
         call gscspc(1,3,-0.1,6.3)      ! set x scale
         call gscspc(2,3,-1.2,1.2)      ! set y scale
         call grafxe(zx,zsin,nsize,zxdata,zdata,nsiz2,
     >      nsiz2,zerx,nsiz2,zery,'x','y',zlbl,
     >      'f(x) as fit around data, with error bars','y=sin(x)')
         call gscspc(1,1,zdum,zdum)     ! restore x autoscaling
         call gscspc(2,1,zdum,zdum)     ! restore y autoscaling
      else if(lchar('G')) then
C  plot of f(x,y)
         call grf3f1(zx,f2d,zy,zwk,nsize,nsizy,nsize,
     >      'x (0 to 2pi)','cos(2x)cos(y)','y (0 to 2pi)',
     >      'x','f','y','tgtest display test program','grf3f1 test',0)
      else if(lchar('C')) then
C  contours plot
         do i=1,4
            iselec(i)=i
         enddo
C
         mnlab(1)='tgtest:  grfmm1 test plot'
         mnlab(2)='contours for x btw 0 and 2pi'
         mnlab(3)='(cos(x),cos(x)), (cos(x),sin(n*x)), n=1,2,3'
C
         kylab(1)='z label'
         kylab(2)='z units'
         kylab(3)='kylab(3)'
         kylab(4)='kylab(4)'
         kylab(5)='kylab(5)'
C
         lbsel(1)='contour 1'
         lbsel(2)='contour 2'
         lbsel(3)='contour 3'
         lbsel(4)='contour 4'
C
         call grfmm1(rc,yc,nsize,nsize,1,zz,4,iselec,4,
     >      'r','y',mnlab,kylab,lbsel)
      else
         call uermsg('%tgtest:  unrecognized menu option.',' ',0)
      endif
C
      go to 10
C
      end

C       SGDUMMY.FOR  Dummy routines for the PLOT-10 based SGLIB package.
c
C
C Mod:
C       01/04/03 DMC -- cleanup (prep for REAL*8 conversion, removing
C                unused floating point stuff).
C       01/17/01 RGA Added a few more to the end
C 	02/03/95 TBT Deleted many routines that are now defined in lhheat.
c
      subroutine npts
      return
      end
c
      subroutine movabs
      return
      end
 
      subroutine symout
      return
      end
 
      subroutine rcontr
      return
      end
 
      subroutine AGIHID
      return
      end
 
      subroutine AGINIT
      return
      end
 
      subroutine AGISOM
      return
      end
 
      subroutine AGISTX
      return
      end
 
      subroutine AGISTY
      return
      end
 
      subroutine AGRAPH
      return
      end
 
      subroutine AGTCGT
      return
      end
 
      subroutine AGTCHS
      return
      end
 
      subroutine AGTCVS
      return
      end
 
      subroutine AGTMHS
      return
      end
 
      subroutine AGXCGT
      return
      end
 
      subroutine AGXCHS
      return
      end
 
      subroutine AGXCVS
      return
      end
 
      subroutine AGXMHS
      return
      end
 
      subroutine BINITT
      return
      end
 
      subroutine CHECK
      return
      end
 
      subroutine CHRSIZ
      return
      end
 
      subroutine CONTUR
      return
      end
 
      subroutine CPLOT
      return
      end
 
      subroutine DINITY
      return
      end
 
      subroutine DLIMX
      return
      end
 
      subroutine DLIMY
      return
      end
 
      subroutine DSPLAY
      return
      end
 
      subroutine ERASE
      return
      end
 
      subroutine FINITT
      return
      end
 
      subroutine FRAME
      return
      end
 
      subroutine INITT
      return
      end
 
      subroutine LINE
      return
      end
 
      subroutine NEWPAG
      return
      end
 
      subroutine PLACE
      return
      end
 
      subroutine RINITT
      return
      end
 
      subroutine SLIMX
      return
      end
 
      subroutine SLIMY
      return
      end
 
      subroutine STEPS
      return
      end
 
      subroutine SYMBL
      return
      end
 
      subroutine UPAUSE
      return
      end
 
      subroutine UPAUCH
      return
      end
 
      subroutine XFRM
      return
      end
 
      subroutine XMFRM
      return
      end
 
      subroutine XNEAT
      return
      end
 
      subroutine XTYPE
      return
      end
 
      subroutine YFRM
      return
      end
 
      subroutine YLOC
      return
      end
 
      subroutine YLOCRT
      return
      end
 
      subroutine YMFRM
      return
      end
 
      subroutine YNEAT
      return
      end
 
      subroutine YTYPE
      return
      end
 
      subroutine agfclos(idum)
      return
      end
 
 
 
C	TBT 6/9/92 Ignat Graphics Dummy COde for Lower Hybrid
C                  From Vax Ignat$:[TRANSP]DumySG.f
 
c     DumySG.F begins
C      SUBROUTINE SetWindw(side, xlow, xup, ylow, yup)
C      return
C      END
C      SUBROUTINE endpl12
C      return
C      END
C      SUBROUTINE mkCont12(ny, yAxis, nx, xAxis, n1dim, wBar,
C     ^     wTitle,
C     ^     xTitle, yTitle, labels, nrLines, incLabls, xWindMin,
C     ^     xWindMax, yWindMin, yWindMax, xlow, xup, ylow, yup)
C      return
C      END
C      SUBROUTINE FeOutUnU
C      return
C      END
C      SUBROUTINE initia
C      return
C      END
C      SUBROUTINE finish(FinFlag1,FinFlag2)
C      return
C      END
C      SUBROUTINE EZdra ( x, y, i )
C      return
C      END
C      SUBROUTINE EZcros( x, y, n )
C      return
C      END
C      SUBROUTINE EZsets(i,j,k,l,a,b,c,d,kind)
C      return
C      END
C      SUBROUTINE EZaxes ( incx , incxi , incy , incyi )
C      return
C      END
C      SUBROUTINE EZscal ( incx , incxi , incy , incyi )
C      return
C      END
C      SUBROUTINE EZsymb(x,y,n,ascii)
C      return
C      END
C      SUBROUTINE EZwrit(i,j,string,lcen,lor)
C      return
C      END
C      SUBROUTINE  EZcurv (x,y,n)
C      return
C      END
C      SUBROUTINE EZpnts(x,y,n)
C      return
C      END
C      SUBROUTINE EZpnt2(x,y,n)
C      return
C      END
C      SUBROUTINE EZbars(x,y,n,ch)
C      return
C      END
C      SUBROUTINE EZeras (i,ii)
C      return
C      END
C      SUBROUTINE EZnorm ( fin , fout , fmin , fmax , n , iCross0)
C      return
C      END
C      SUBROUTINE EZrcon (i,j,k,l,a,b,c,d,
C     ^  kclev1,clevelin,kclev2,
C     ^  AryContr,
C     ^  i1stdim,
C     ^  xAry, ixmin, ixmax, ixstep,
C     ^  yAry, jymin, jymax, jystep )
C	Return
C	End    ! tbt 9/1/92
C      SUBROUTINE EZrndu(r,x,i)
C      return
C      END
C      SUBROUTINE round( r , x, i, ii )
C      return
C      END
C      SUBROUTINE SysSetUp
C      return
C      END
C      SUBROUTINE SysClose
C      return
C      END
c      Subroutine frdwi(I)       ! tbt 11/5/92
c	return
c      End
 
c      SUBROUTINE plstyp(PlotType)
c      return
c      END
c      SUBROUTINE mkcontpl(ny, yAxis, nx, xAxis, n1dim, w_bar, wTitle,
c     ^     xTitle, yTitle, labels, nrLines, incLabls, xWindMin,
c     ^     xWindMax, yWindMin, yWindMax, xlow, xup, ylow, yup)
c      return
c      END
C      SUBROUTINE wrlevels(ncont, c, ixStart, iyStart)
C      return
C      END
C      SUBROUTINE mkLabels(labels, nrLines, ixStart, iyStart)
C      return
C      END
C      SUBROUTINE mkLevels(scale, ncont, vec, vmin, vmax, kZero)
C      return
C      END
C      SUBROUTINE plvecLab(n, xAxis, y, xTitle, yTitle, labels,
C     ^     incLabls, nrLines)
C      return
C      END
C      SUBROUTINE plMultip(npoints, ncurves, xx, yy, xTitle, yTitle
C     ^     , labels, incLabls, nrLines)
C      return
C      END
 
C      Real FUNCTION EZlilo (x)
C      EZlilo = 1.
C      return
C      End
 
C      Subroutine XRAYCAM2         ! Used in LSC.    tb 1/16/93
C	Return
C      END
 
C      SUBROUTINE mwpl12(Title, mat, wind, PlotType, side)
C      CHARACTER *(*) Title
C      INTEGER wind(4), PlotType, side
C      REAL    mat
C      return
c     DumySg.F ends
 
C      END
 
      SUBROUTINE ENDDUMB
      END
 
      subroutine agccurv
      return
      end
 
      subroutine agdspl
      return
      end
 
      subroutine agcsymb
      return
      end
 
      subroutine agclini
      return
      end
 
      subroutine agcolrs
      return
      end
 
      subroutine agcfram
      return
      end
 
      subroutine r4_agcfram
      return
      end
 
      subroutine r4_rcontr
      return
      end
 
      subroutine bsyms
      return
      end
 
      subroutine r8_seedw
      return
      end
 
      subroutine r8_agclins
      return
      end
 
      subroutine r8_agraph
      return
      end
 
      subroutine r8_agcxget
      return
      end
 
      subroutine r8_agcyget
      return
      end
 
      subroutine r8_agcplst
      return
      end
 
      subroutine r8_agncof
      return
      end
 
      subroutine r8_rcontr
      return
      end
 
      subroutine r8_contur
      return
      end
 
      subroutine r8_agclxy
      return
      end
 
      subroutine r8_agcuset
      return
      end
 
      subroutine r8_agculev
      return
      end
 
      subroutine r8_agrcfr
      return
      end
 
      subroutine r8_agcfram
      return
      end
 
      subroutine r8_check
      return
      end
 
      subroutine r8_dsplay
      return
      end
 
      subroutine r8_agdspl
      return
      end
 
      subroutine r8_agmnmx
      return
      end
 
      subroutine r8_mnmx
      return
      end
 
      subroutine r8_cplot
      return
      end
 
      subroutine r8_agkeys
      return
      end
 
      subroutine r8_bsyms
      return
      end
 
      subroutine r8_symout
      return
      end
 
      subroutine r8_teksym
      return
      end
 
      subroutine r8_ageya
      return
      end
 
      subroutine r8_agexa
      return
      end
 
      subroutine r8_agexs
      return
      end
 
      subroutine r8_agexsr
      return
      end
 
      subroutine r8_dlimx
      return
      end
 
      subroutine r8_dlimy
      return
      end
 
      subroutine r8_agvcur
      return
      end
 
      subroutine r8_vcursr
      return
      end
 
      subroutine r8_movea
      return
      end
 
      subroutine r8_mover
      return
      end
 
      subroutine r8_drawa
      return
      end
 
      subroutine r8_drawr
      return
      end
 
      subroutine r8_pointa
      return
      end
 
      subroutine r8_dasha
      return
      end
 
      subroutine r8_wincot
      return
      end
 
      subroutine r8_revcot
      return
      end
 
      subroutine r8_agisoc
      return
      end
 
      subroutine r8_agisom
      return
      end
 
      subroutine r8_agidlx
      return
      end
 
      subroutine r8_agidlz
      return
      end
 
      subroutine r8_agidly
      return
      end
 
      subroutine r8_agicau
      return
      end
 
      subroutine r8_agclgen
      return
      end
 
      subroutine movea
      return
      end
 
      MODULE sglib_mod
      END MODULE sglib_mod

C  MULCDRB
C
C  J F Schivell  23 Aug 95  --  based on MULCDR; removed key
C
C  DRAW MULTIPLE (X,Y) CONTOURS  - BASED ON MULFDR - DMC 9/84
C
C  DRAW A MULTIPLOT WITH KEY.
C  CALLER SETS SCALE AND AXIS TYPE
C
C  DATA TO BE PLOTTED IS PASSED IN 2D ARRAYS
C
C  NO USER I/O OR CONTROL IS PROVIDED EXCEPT TO CALL UPAUST AFTER
C  THE MULTIPLOT IS COMPLETE
C
      SUBROUTINE MULCDRB(
     >   R,Y,ND1,NC,NNC,Z,NZ,ISELF,NSEL,IAXSEL,
     >   RUN,YUN,MNLAB)
C
      use bottoms_up
C
C  # SYMBOLS PER LINE (MAX)
      implicit NONE
      integer, PARAMETER :: NSYMBS=5
C
C  ARGUMENTS -- ALL MUST BE SUPPLIED BY CALLER (OUTPUT IS GRAPH)
C
C  IN COMMON/DPLOT1/  XMIN,XMAX,YMIN,YMAX -- THE SCALE OF THE GRAPH
C
C  PASSED:
c
C   R(ND1,NZ)  DATA BUFFER OF INDICATED DIMENSIONS-- HORIZONTAL CONTOUR
C              PARAMETRIZATION
C   Y(ND1,NZ)  DATA BUFFER OF INDICATED DIMENSIONS-- VERTICAL CONTOUR
C              PARAMETRIZATION
C
C  **NC** IS THE ACTUAL NUMBER OF PTS IN EACH CONTOUR (.LE.ND1)
C   NC(NNC) -- NC(1) IS THE NO. OF PTS IN THE 1ST CONTOUR ...
C              NC(MIN(NZ,NNC)) IS THE NO. OF PTS IN THE NZ'TH CONTOUR
C              NOTE THAT BY PASSING NNC=1 ONE MAY SPECIFY THE SAME
C              NO. OF POINTS IN ALL CONTOURS, OR BY SETTING NNC=NZ
C              AND FILLING THE NC INTEGER ARRAY ONE MAY HAVE A DIFFERENT
C              NO. OF POINTS FOR EACH CONTOUR.  HOWEVER,
C                  2 .LE. NC(J) .LE. ND1
C              MUST BE MAINTAINED FOR ALL J BTW 1 AND MIN(NZ,NNC)
C
C   Z(NZ)      CONTOUR INDEXING
C
C   ISELF(NSEL) SELECTS WHICH CONTOURS ARE TO APPEAR
C     ON THE MULTIPLOT.
C   **NSEL** IS THE NUMBER OF CURVES TO APPEAR ON THE MULTIPLOT
C
C   IAXSEL      SELECTS THE AXIS TYPE:
C     =-11 FOR LINEAR-LINEAR
C     =-15 FOR LINEAR-LOG(Y)
C     =-30 FOR LOG(X)-LOG(Y)
C     =-40 FOR LOG(X)-LINEAR
C   -----------
C   CHARACTER LABELS:
C   ------------
C    RUN        10 CHAR HORIZONTAL AXIS PHYSICAL UNITS LABEL
C    YUN        10 CHAR VERTICAL AXIS PHYSICAL UNITS LABEL
C
C   MNLAB       3 60 CHARACTER "MAIN LABELS"-- 1ST TWO APPEAR
C               ABOVE GRAPH, LAST ONE BELOW
C
      INCLUDE 'PLOT1MMX'
C
      integer nd1,nz,nnc,iaxsel,nsel,irast
      REAL R(ND1,NZ),Y(ND1,NZ),Z(NZ)
      INTEGER ISELF(NSEL)
      INTEGER NC(NNC)
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) RUN,YUN
C
C  LOCAL VARIABLES-- DETERMINE LOCATION OF LABELS,
C     SIZE OF GRAPH, ETC.
C
      REAL ZXL(NSYMBS),ZYL(NSYMBS)
C--------------------------
C  other local stuff
C
      integer inum,inums,immnb,intvl,isinc,ist,i,ind,icod,ijust,iwarn
      real zzx,zzy
      character*64 wname
      character*40 gname,dname
      character*10 zext
C
C  USE MULFDR INCLUDE FILE FOR DATA RE. RASTER LOCATIONS OF VARIOUS
C  PLOT COMPONENTS, LABELS, ETC.
C
      INCLUDE 'MULFDR_BLK'
C--------------------------------------------------
C  START OF EXECUTABLE CODE
C
      call bu_eval(mnlab(3),' ',irast)  ! check for multi-line lower label
C
C  # PTS IN FIRST CURVE
      INUM=NC(1)
C  # OF PTS IN PLOT WINDOW
      INUMS=MAX0(1,IMMNB(R(1,ISELF(1)),Y(1,ISELF(1)),INUM))
C  SYMBOL SPACING VARIABLES
      INTVL=MAX0(1,(INUMS+NSYMBS-1)/NSYMBS)
      IF(INTVL.LT.NSYMBS) THEN
        ISINC=INTVL-1
      ELSE
        ISINC=INTVL/NSYMBS
      ENDIF
C
      IST=MAX0(1,(INTVL/2-ISINC))
C
C  DRAW AXES
C
      ZZX=XMAX+5.0*(XMAX-XMIN)
      ZZY=YMAX+5.0*(YMAX-YMIN)
      CALL DPLOTM(IXRG,IYRG,ZZX,ZZY,1,IAXSEL)
C
C  PLOT THE CURVES
C
      DO 30 I=1,NSEL
C
        INUM=NC(MIN0(I,NNC))  ! NO. OF PTS THIS CURVE
C
        IND=ISELF(I)          ! INDEX
C
C  LINE STYLE CODE
        ICOD=1
C  PLOT CONTOUR CURVE
        CALL DPLOTM(IXRG,IYRG,R(1,IND),Y(1,IND),INUM,ICOD)
 30   CONTINUE
C
C  DRAW KEY FRAME
C
      CALL MOVABS(IXRG(2),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(2))
C  FUNCTION UNITS
      CALL GRFLBL(IXRXU,IYRXU+irast,RUN,0,-1,0)
      CALL GRFLBL(IXRFU,IYRFU,YUN,0,-1,1)
C  MAIN GRAPH LABELS
      IJUST=-1
      DO I=1,3
         if(i.le.2) then
            CALL GRFLBL(IXRMN,IYRMN(I),MNLAB(I),60,IJUST,0)
         else
            ijust=0
            if(ibrk_lbl3.eq.0) then
               CALL GRFLBL(IXRMN,IYRMN(I),MNLAB(I),60,IJUST,0)
            else
               call grflbl(ixrmn,iyrmn(i)+irast,
     >              mnlab(i)(1:ibrk_lbl3),60,ijust,0)
               call grflbl(ixrmn,iyrmn(i),
     >              mnlab(i)(ibrk_lbl3+1:),60,ijust,0)
            endif
         endif
      ENDDO
C ---------
C GRAPH COMPLETED
C
      CALL UPAUST(2)

      call bu_reset

      RETURN
      END

c---- tstcon.for	sg demo				21-jan-82
c
c  test sglib contour routines
c
	program contour
	integer   ipole
	character back*1
c
	ipole = 0
	call at_bint('Number of poles plots',ipole,back)
	do n=1,ipole
	  call poles
	enddo
c
	end
c%
	subroutine poles
	USE SGLIB_MOD
c
c---- this contour plot was submitted by hedi selberg.
c
	parameter (mx=51)
	parameter (my=101)
	real*4 x(mx),y(my),th(mx),rr(my)
	real*4 x2(mx,my),y2(mx,my),a(mx,my),c(40)
        real*4 xmax
cx	integer kolors(6) /2,3,4,5,6,7/
	integer icall
	real cfirs
	integer nx, ny
	data icall /1/
	data cfirs /-.05/
	data nx /12/, ny /12/
 
	external polpro
c
	call at_int('Rcontr (1), Contur (2)',icall)
	call at_real('First contour level',cfirs)
	call at_int('Number of x points',nx)
	call at_int('Number of y points',ny)
	p2=6.2831852
	dx=1./nx
	do i=1,nx
	  x(i)=p2*i*dx
	enddo
	dy=1./ny
	do j=1,ny
	  y(j)=p2*j*dy
	enddo
	dr=1./(ny)
	dth=p2/(nx)
	do j=1,ny
	  yy=p2*(j)*dy
	  rr(j)=(j)*dr
	  do i=1,nx+1
	    th(i)=(i-1)*dth
	    xx=p2*(i)*dx
	    a(i,j)=sin(yy)*cos(xx)
	    x2(i,j)=rr(j)*cos(th(i))
	    y2(i,j)=rr(j)*sin(th(i))
	  enddo
	enddo
c
	call initt(120)
cx	call binitt
cx	call slimx(150,750)	!default is 150,900
cx	call slimy(100,500)	!default is 125,700
cx	call agrcfr(x,1,nx,2,y,1,ny,2,1)
	c(1)=cfirs	!first solid (fnc min = -2.05)
	c(2)=.1		!increment
	k1=0		!c(1)=f0, c(2)=df, z<c(1) is dotted
	k2=0
	if(icall.eq.1) then
	  call agraph(150,750,100,500,
     >		x(1),x(nx-1),y(1),y(ny-1),'X','Y')
	  call rcontr(k1,c,k2,a,mx,x,1,nx,2,y,1,ny,2)
	elseif(icall.eq.2) then
	  xmax=rr(ny)*.8
	  call agraph(150,750,100,500,
     >		-xmax,xmax,-xmax,xmax,'X','Y')
	  call contur(k1,c,k2,a,mx,x2,1,nx+1,1,y2,1,ny,1)
	elseif(icall.eq.3) then
	  xmax=rr(ny)*.8*.6
	  call agraph(150,750,100,500,
     >		-xmax,xmax,-xmax,xmax,'X','Y')
	  call contur(k1,c,k2,a,mx,x2,1,nx+1,1,y2,1,ny,1)
	endif
	call agxmhs(350,600,'POLES: A CONTOUR PLOT$')
	call upause(0)
	call finitt(0,0)
	return
	end
	subroutine polpro(x,y,px,py)
	px=y*cos(x)
	py=y*sin(x)
	end

subroutine chk_interpolate(zprof,xi,nx)
  !
  !  patch "holes" (zero values) in profile,
  !  then smooth.
  !
  !  done for MC radial profiles that are formed by summing of the
  !  profile itself and its normalization
  !
  !    zprof(j) = [MC sum]f*dw
  !    zwsum(j) = [MC sum]dw
  !
  !  and at normalization time
  !
  !    if (zwsum(j).gt.0.0) then
  !         zprof(j)=zprof(j)/zwsum(j)
  !    else
  !         zprof(j)=0.0
  !    endif
  !
  !  which can leave "holes" in the profile in case of lousy statistics.
  !
  !  *** SO ***
  !  fill these holes with linear extrapolation & linear interpolation
  !
  !-----------------------------
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), dimension(nx)::zprof,xi
  integer :: nx
  !
  !
  real(fp) :: zx1,zf1,zx2,zf2,zx,zf
  !
  integer :: j,jnz,jj,isrch,jsave1,jsave2
  !
  !-----------------------------
  !
  !  1.  fill in from left
  !
  do j=1,nx
    if(zprof(j).ne.0.0_fp) go to 10
  enddo
  !
  go to 1000                        ! all zero:  exit now...
  !
10 continue
  jnz=j
  do jj=1,jnz-1
    zprof(jj)=zprof(jnz)
  enddo
  !
  !  2.  fill in from right
  !
  do j=nx,1,-1
    if(zprof(j).ne.0.0_fp) go to 20
  enddo
  !
20 continue
  jnz=j
  do jj=nx,jnz+1,-1
    zprof(jj)=zprof(jnz)
  enddo
  !
  !  3.  fill in remaining gaps with linear interpolation
  !
  isrch=1
  do j=1+1,nx-1
    if(isrch.eq.1) then
      !  find start of zeroed section
      if(zprof(j).eq.0.0_fp) then
        jsave1=j-1
        zx1=xi(jsave1)
        zf1=zprof(jsave1)
        isrch=2
      endif
    else if(isrch.eq.2) then
      !  find end of zeroed section
      if(zprof(j).ne.0.0_fp) then
        jsave2=j
        zx2=xi(jsave2)
        zf2=zprof(jsave2)
        isrch=1
        !  apply patch
        do jj=jsave1+1,jsave2-1
          zx=xi(jj)
          zf=zf1+(zf2-zf1)*(zx-zx1)/(zx2-zx1)
          zprof(jj)=zf
          zprof(jj)=max(0.0_fp,zprof(jj))
        enddo
      endif
    endif                          ! isrch mode
  enddo                             ! j loop
  !
1000 continue
  return
end subroutine chk_interpolate
